export function promisify(f, thisContext) {
    return function () {
        var args = Array.prototype.slice.call(arguments);
        return new Promise(function (resolve, reject) {
            args.push(function (err, result) { return err ? reject(err) : resolve(result); });
            f.apply(thisContext, args);
        });
    };
}
