import { IEnvironment } from '@image/packer';
export default class NodeEnvironment implements IEnvironment {
    private filePath;
    private tempPath;
    private data;
    private log;
    private cacheMissesCurrentlyInProgress;
    constructor(tempPath: string, log: any);
    calculateHash(filePath: string): Promise<string>;
    createHash(string: any): string;
    lookup(type: string, key: string, cacheMissFunction: () => any, version?: any): Promise<any>;
    getCachePath(basename: string): string;
    save(): Promise<void>;
    clean(): Promise<void>;
    load(): Promise<void>;
    cleanPath(dir: string): Promise<void>;
    copyTo(targetFilePath: string, toPath: string): Promise<void>;
    joinPaths(...paths: string[]): string;
    ensureDir(dir: string): Promise<void>;
    glob(pattern: string): Promise<string[]>;
    writeFile(outputFilePath: string, raw: string): Promise<void>;
}
